;(function($){
  'use strict';
    jQuery(document).ready(function($) {

        /***** Colour picker *****/

        jQuery('.colorpicker').hide();
        jQuery('.colorpicker').each( function() {
            jQuery(this).farbtastic( jQuery(this).closest('.color-picker').find('.color') );
        });

        jQuery('.color').on("click", function($){
            jQuery(this).closest('.color-picker').find('.colorpicker').fadeIn();
        });

        jQuery(document).mousedown(function() {
            jQuery('.colorpicker').each(function() {
                var display = $(this).css('display');
                if ( display == 'block' )
                    jQuery(this).fadeOut();
            });
        });


        /***** Uploading images *****/

        var file_frame;

        function attachment_url( button, preview_media ) {
            var button_id = button.attr('id');
            var field_id = button_id.replace( '_button', '' );
            var preview_id = button_id.replace( '_button', '_preview' );

            // If the media frame already exists, reopen it.
            if ( file_frame ) {
              file_frame.open();
              return;
            }

            // Create the media frame.
            file_frame = wp.media.frames.file_frame = wp.media({
              title: jQuery( this ).data( 'uploader_title' ),
              button: {
                text: jQuery( this ).data( 'uploader_button_text' ),
              },
              multiple: false
            });

            // When an image is selected, run a callback.
            file_frame.on( 'select', function() {
              var attachment = file_frame.state().get('selection').first().toJSON();
    		  //console.log(attachment);
              $("#"+field_id).val(attachment.id);
              if( preview_media ) {
              	$("#"+preview_id).attr('src',attachment.url);
              }
            });

            // Finally, open the modal
            file_frame.open();
        }

        jQuery('.image_upload_button').on("click", function(){
            attachment_url( jQuery(this), true );
        });

        jQuery('.image_delete_button').on("click", function(e){
            jQuery(this).closest('td').find( '.image_data_field' ).val( '' );
            jQuery( '.image_preview' ).remove();
            return false;
        });


        /***** Navigation for settings page *****/

        // Make sure each heading has a unique ID.
        jQuery( 'ul#settings-sections.subsubsub' ).find( 'a' ).each( function ( i ) {
            var id_value = jQuery( this ).attr( 'href' ).replace( '#', '' );
            jQuery( 'h2:contains("' + jQuery( this ).text() + '")' ).attr( 'id', id_value ).addClass( 'section-heading' );
        });
    	// if load
    	// If the link is a tab, show only the specified tab.
    	var toShow = jQuery( '#wooevents .subsubsub li:first-child a.tab' ).attr( 'href' );
    	jQuery( '#wooevents .subsubsub li:first-child a.tab' ).addClass( 'current' );
        jQuery( '#wooevents .subsubsub li:first-child' ).addClass( 'active' );
    	// Remove the first occurance of # from the selected string (will be added manually below).
    	toShow = toShow.replace( '#', '');

    	jQuery( '#wooevents h2, #wooevents form > p:not(".submit"), #wooevents table' ).hide();
    	jQuery( 'h2#' + toShow ).show().nextUntil( 'h2.section-heading', 'p, table, table p' ).show();
        // Create nav links for settings page
        function we_setting_active($this){
            $this.parents( '.subsubsub' ).find( '.current' ).removeClass( 'current' );
            $this.parents( '.subsubsub' ).find( '.active' ).removeClass( 'active' );
            $this.closest('li').addClass( 'active' );
            $this.addClass( 'current' );
            // If "All" is clicked, show all.
            //if ( jQuery( this ).hasClass( 'all' ) ) {
                //jQuery( '#wooevents h2, #wooevents form p, #wooevents table.form-table, p.submit' ).show();

                //return false;
            //}

            // If the link is a tab, show only the specified tab.
            var toShow = $this.attr( 'href' );
            window.location.hash = toShow;
            // Remove the first occurance of # from the selected string (will be added manually below).
            toShow = toShow.replace( '#', '');//toShow.replace( '#', '', toShow );

            jQuery( '#wooevents h2, #wooevents form > p:not(".submit"), #wooevents table' ).hide();
            jQuery( 'h2#' + toShow ).show().nextUntil( 'h2.section-heading', 'p, table, table p' ).show();
        }
        var hash = window.location.hash;
        if(hash!=''){
            var $this = $('a[href="'+hash+'"]');
            we_setting_active($this);
        }
        jQuery( '#wooevents .subsubsub a.tab' ).on("click", function(e){
            // Move the "current" CSS class.
            var $this = jQuery( this );
            we_setting_active($this);

            return false;
        });
        jQuery( 'body' ).on("click", "#wooevents .exwe-atrq a", function(e){
            var toShow = $(this).attr( 'href' );
            hash = toShow.split('#')[1];
            if(hash!=''){
                var $this = $('a[href="#'+hash+'"]');
                we_setting_active($this);
            }
            return false;
        });
        // Add hash to action
        $("#wooevents .submit input").on("click", function(e){
            e.preventDefault();
            var hash = window.location.hash;
            var $action = $('#wooevents > form').attr('action')+hash;
            $('#wooevents > form').attr('action', $action).submit();
        });
    });
}(jQuery));