<?php
class WooEvent_ShowMeta {
	public function __construct()
    {
    	$theme_name = wp_get_theme();
		add_action( 'woocommerce_single_product_summary', array( &$this,'woocommerce_single_ev_meta') );
		add_action( 'woocommerce_after_single_product_summary', array( &$this,'woocommerce_single_ev_schedu') );
		/*-Support TheGem theme-*/
		if($theme_name =='TheGem'){
			add_action( 'thegem_woocommerce_single_product_right', array( &$this,'woocommerce_single_ev_meta') );
		add_action( 'thegem_woocommerce_single_product_bottom', array( &$this,'woocommerce_single_ev_schedu') );
		}
		add_filter( 'woocommerce_product_description_heading',  array( &$this,'wc_change_product_description_tab_title'), 10, 1 );
		add_filter( 'woocommerce_product_single_add_to_cart_text', array( &$this,'woo_custom_cart_button_text'));  

		add_action('woocommerce_before_single_product',array( &$this,'add_info_before_single'),11);

		add_action( 'woocommerce_email_before_order_table', array( &$this,'woocommerce_email_hook'));
		add_filter( 'woocommerce_cart_item_name', array( &$this,'woocommerce_cart_hook'), 10, 3 );
		add_filter ('woocommerce_add_to_cart_redirect', array( &$this,'woocommerce_redirect_to_checkout'));
		add_filter( 'woocommerce_add_to_cart_validation', array( &$this,'validate_add_cart_item'), 10, 5 );
		add_action( 'woocommerce_shop_loop_item_title', array( &$this,'we_add_ev_meta' ),12);
		add_action( 'woocommerce_before_shop_loop_item',  array( &$this,'woocommerce_shopitem_ev_meta'),99 );

		add_action( 'woocommerce_after_main_content', array( &$this,'woocommerce_next_previous_event'));
    }
	// Stop event booking before X day event start
	function validate_add_cart_item( $passed, $product_id, $quantity, $variation_id = '', $variations= '' ) {
	
		// do your validation, if not met switch $passed to false
		if ( we_hide_booking_form()!='' ){
			$passed = false;
			$t_stopb = get_option('we_text_stopb')!='' ? get_option('we_text_stopb') : esc_html__('Tickets not available','exthemes');
			wc_add_notice( $t_stopb, 'error' );
		}
		return $passed;
	
	}
	//change text
	function wc_change_product_description_tab_title( $heading ) {
		global $woocommerce, $post;
		$we_layout_purpose = we_global_default_spurpose();
		if($we_layout_purpose!='event'){
			$heading = get_option('we_text_details')!='' ? get_option('we_text_details') : esc_html__('Details','exthemes');
		}else{
			$heading = get_option('we_text_evdetails')!='' ? get_option('we_text_evdetails') : esc_html__('Event Details','exthemes');
		}
		return $heading;
	}
	//remove button if event pass
	function add_info_before_single(){
		global $woocommerce, $post;
		$time_now =  strtotime("now");
		$we_enddate = we_global_enddate() ;
		$we_layout_purpose = we_global_default_spurpose();
		$we_enable_sginfo = get_option('we_enable_sginfo');
		$id_user = get_current_user_id();
		
		$we_time_zone = get_post_meta($post->ID,'we_time_zone',true);
		if($we_time_zone!='' && $we_time_zone!='def'){
			$we_time_zone = $we_time_zone * 60 * 60;
			$time_now = $we_time_zone + $time_now;
		}
		$all_day = get_post_meta($post->ID,'we_allday', true );
		if( $all_day == 1){
			$date_notime = date('Y-m-d',$we_enddate);
			$we_enddate = strtotime($date_notime) + 86399;
		}
		if($time_now > $we_enddate && $we_enddate!='' && $we_layout_purpose=='event'){
			$evpasstrsl = get_option('we_text_event_pass')!='' ? get_option('we_text_event_pass') : esc_html__('This event has passed','exthemes');
			echo '
			<div class="alert alert-warning tour-mes-info event-info"><i class="fa fa-exclamation-triangle"></i>'.wp_kses_post($evpasstrsl).'</div>';
		}else if($we_enable_sginfo=='on' && $id_user!=0 && wc_customer_bought_product('',$id_user, $post->ID)){
			$evsg_info = get_option('we_text_usersg')!='' ? get_option('we_text_usersg') : esc_html__('You already signed up this event','exthemes');
			echo '<div class="alert alert-warning tour-mes-info event-info"><i class="fa fa-exclamation-triangle"></i>'.$evsg_info.'</div>';
		}
	}// global $date
	
	function woo_custom_cart_button_text($text) {
	 	$we_text_join_ev = get_option('we_text_join_ev');
		global $woocommerce, $post;
		$_product = wc_get_product( $post->ID );
		if( $_product->is_type( 'external' ) ){
        	return $text;
        }
		$we_main_purpose = we_global_main_purpose();
		$we_layout_purpose = we_global_default_spurpose();
		if($we_layout_purpose!='event'){
			return get_option('we_text_add_to_cart')!='' ? get_option('we_text_add_to_cart') : esc_html__( 'Add To Cart', 'exthemes' );
		}
		if($we_text_join_ev!=''){
			return $we_text_join_ev;
		}else{
			return esc_html__( 'Join this Event', 'exthemes' );
		}
	 
	}
	// Single Custom meta 
	function woocommerce_single_ev_meta() {
		global $woocommerce, $post;
		$we_layout_purpose = we_global_default_spurpose();
		if($we_layout_purpose=='event'){
			wooevent_template_plugin('event-meta');
		}
			
	}
	function woocommerce_single_ev_schedu() {
		global $woocommerce, $post;
		$we_layout_purpose = we_global_default_spurpose();
		
		if($we_layout_purpose=='event'){
			wooevent_template_plugin('event-schedu');
		}
	}
	// Email hook
	function woocommerce_email_hook($order){
		$event_details = new WC_Order( $order->get_id() );
		global $event_items;
		$event_items = $event_details->get_items();
		wooevent_template_plugin('email-event-details');

	}
	// Cart hook
	function woocommerce_cart_hook($_product_title,$cart_item, $cart_item_key){
		if(get_option('we_old_layout')!='yes' && exwe_get_layout_purpose($cart_item['product_id']) =='woo'){ return $_product_title;}
		if(!is_cart() && !is_checkout()){ return $_product_title;}
		$we_startdate = get_post_meta( $cart_item['product_id'], 'we_startdate', true );
		$we_enddate = get_post_meta( $cart_item['product_id'], 'we_enddate', true );
		$all_day = get_post_meta($cart_item['product_id'],'we_allday', true );
		$html = $_product_title;
		$stdatetrsl = get_option('we_text_stdate')!='' ? get_option('we_text_stdate') :  esc_html__('Start Date','exthemes');
			$edatetrsl = get_option('we_text_edate')!='' ? get_option('we_text_edate') : esc_html__('End Date','exthemes');
			$alltrsl = get_option('we_text_allday')!='' ? get_option('we_text_allday') : esc_html__('(All day)','exthemes');
		if($all_day!='1' && $we_startdate!=''){
			$html .='<span class="meta-stdate" style="display: block;">'.$stdatetrsl.': '.date_i18n( get_option('date_format'), $we_startdate).' '.date_i18n(get_option('time_format'), $we_startdate).'</span>';
			if($we_enddate!=''){
				$html .='<span class="meta-eddate" style="display: block;">'.$edatetrsl.': '.date_i18n( get_option('date_format'), $we_enddate).' '.date_i18n(get_option('time_format'), $we_enddate).'</span>';
			}
		}elseif($we_startdate!=''){
			$html .='<span class="meta-stdate" style="display: block;">'.$stdatetrsl.': '.date_i18n( get_option('date_format'), $we_startdate).'</span>';
			if($we_enddate!=''){
				$html .='<span class="meta-eddate" style="display: block;">'.$edatetrsl.': '.date_i18n( get_option('date_format'), $we_enddate).' '.$alltrsl.'</span>';
			}
		}
		return $html;

	}
	// redirect to checkout
	function woocommerce_redirect_to_checkout($wc) {
		if(get_option('we_enable_cart')=='off'){
			global $woocommerce;
			$checkout_url = wc_get_checkout_url();
			return $checkout_url;
		}
		return $wc;
	}
	// add event info to shop page
	function we_add_ev_meta(){
		global $woocommerce, $post;
	  	$hml = '';
		$we_startdate = get_post_meta( $post->ID, 'we_startdate', true );
		$we_enddate = get_post_meta( $post->ID, 'we_enddate', true );
		global $product;	
		$type = $product->get_type();
		$price_html = $product->get_price();
		$price = '';
		if($type=='variable'){
			$price = we_variable_price_html();
		}else{
			if ( $price_html = $product->get_price_html() ) :
				$price = $price_html;
			endif; 	
		}
		if($we_startdate!=''){ 
			$hml = '
			<div class="shop-we-more-meta">
				<span><i class="fa fa-calendar"></i>'.date_i18n( get_option('date_format'), $we_startdate).'</span>';
				if(get_option('we_dis_status') !='yes'){
				$hml .= '
					<span>
						<i class="fa fa-ticket"></i>
						'.woo_event_status( $post->ID, $we_enddate).'
					</span>';
				}
				$hml .='
			</div>';
		}
		$ft_html = apply_filters( 'we_shop_ev_meta', $hml, $we_startdate, $price, $we_enddate );
		echo exwe_dataes($ft_html);
	}
	// Add meta to item of shop
	function woocommerce_shopitem_ev_meta(){
		global $woocommerce, $post;
		$we_startdate = get_post_meta( $post->ID, 'we_startdate', true );
		if(!function_exists('we_event_custom_color')){ return;}
		$we_eventcolor = we_event_custom_color($post->ID);
		if($we_eventcolor==''){$we_eventcolor = we_autochange_color();}
		$bgev_color = '';
		if($we_eventcolor!=""){
			$bgev_color = 'style="background-color:'.$we_eventcolor.'"';
		}
	
		if($we_startdate!=''){ 
			echo '<div class="shop-we-stdate" '.$bgev_color.'><span class="day">'.date_i18n('d', $we_startdate).'</span>';
			echo '<span class="month">'.date_i18n('M', $we_startdate).'</span></div>';
		}
	}
	// Next Previous link
	function woocommerce_next_previous_event(){
		$we_sevent_navi = get_option('we_sevent_navi');
		global $post;
		if(is_singular('product') && $we_sevent_navi!='off' && get_post_meta( $post->ID, 'we_startdate', true )!=''){
			$args = array( 'post_type' => 'product', 'posts_per_page' => 1, 'orderby'=> 'meta_value_num', 'order' => 'ASC','meta_key' => 'we_startdate', 'meta_value' => get_post_meta( $post->ID, 'we_startdate', true ),  'meta_compare' => '>', );
			$post_nex = get_posts( $args );
			$next_l ='';
			foreach ( $post_nex as $post ) : setup_postdata( $post );
				$next_l = get_the_permalink();
			endforeach; 
			wp_reset_postdata();
			$args_pre = array( 'post_type' => 'product', 'posts_per_page' => 1, 'orderby'=> 'meta_value_num', 'order' => 'DESC','meta_key' => 'we_startdate', 'meta_value' => get_post_meta( $post->ID, 'we_startdate', true ),  'meta_compare' => '<', );
			$post_pre = get_posts( $args_pre );
			$previous_l = '';
			foreach ( $post_pre as $post ) : setup_postdata( $post );
				$previous_l = get_the_permalink();
			endforeach; 
			wp_reset_postdata();
			$we_main_purpose = we_global_main_purpose();
			$html ='<div class="we-navigation">';
			if($previous_l!=''){
				if($we_main_purpose=='woo' || $we_main_purpose=='custom'){
					$pretrsl = get_option('we_text_previous')!='' ? get_option('we_text_previous') :  esc_html__('Previous','exthemes');
					$html .='<div class="previous-event"><a href="'.$previous_l.'" class="exwt-btn exwt-btn-primary"><i class="fa fa-angle-double-left"></i>'.$pretrsl.'</a></div>';
				}else{
					$preevtrsl = get_option('we_text_previousev')!='' ? get_option('we_text_previousev') : esc_html__('Previous Event','exthemes');
					$html .='<div class="previous-event"><a href="'.$previous_l.'" class="exwt-btn exwt-btn-primary"><i class="fa fa-angle-double-left"></i>'.$preevtrsl.'</a></div>';
				}
			}
			if($next_l!=''){
				if($we_main_purpose=='woo' || $we_main_purpose=='custom'){
					$nexttrsl = get_option('we_text_next')!='' ? get_option('we_text_next') : esc_html__('Next','exthemes');
					$html .='<div class="next-event"><a href="'.$next_l.'" class="exwt-btn exwt-btn-primary">'.$nexttrsl.'<i class="fa fa-angle-double-right"></i></a></div>';
				}else{
					$nextevtrsl = get_option('we_text_nextev')!='' ? get_option('we_text_nextev') : esc_html__('Next Event','exthemes');
					$html .='<div class="next-event"><a href="'.$next_l.'" class="exwt-btn exwt-btn-primary">'.$nextevtrsl.'<i class="fa fa-angle-double-right"></i></a></div>';
				}
			}
			$html .='</div><div class="clear"></div>';
			echo  $html;
		}
	}
}
$WooEvent_ShowMeta = new WooEvent_ShowMeta();